'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.wipe = undefined;

var _mocks = require('./mocks');

var _plugins = require('./plugins');

// which one?
var wipe = exports.wipe = module.hot ? require('wipe-webpack-cache') : require('wipe-node-cache');

var primaryResolver = function primaryResolver(stubs, moduleName) {
  return stubs[moduleName];
};

var resolver = function resolver(stubs, moduleName) {
  // never wipe .node(native) module
  if (moduleName.indexOf('\.node') > -1) {
    return false;
  }
  return (0, _plugins.shouldWipe)(stubs, moduleName);
};

var wipeCache = function wipeCache() {
  var primaryCache = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  wipe(primaryCache, primaryResolver);
  wipe((0, _mocks.getAllMocks)(), resolver);
};

exports.default = wipeCache;